<template>
    <div class="card card-primary">
        <div class="card-header">
            <h3 class="card-title">{{title}}</h3>
            <div class="card-tools">
                <div v-if="keepalive == 1">Connecté <i class="fas fa-circle" style="color: #4caf50;"></i></div>
                <div v-else>Déconnecté <i class="fas fa-circle" style="color: #F44336;"></i></div>
            </div>
        </div>
        <div class="card-body" style="position: relative;max-height: 65vh;">
            <div class="text-center">
                <date-range-picker
                    ref="picker"
                    :locale-data="{ firstDay: 1, format: 'DD-MM-YYYY HH:mm:ss' }"
                    v-model="dateRange"
                    @update="getData">
                    <template v-slot:input="picker" style="min-width: 350px;">
                        Du {{ picker.startDate | date }} au {{ picker.endDate | date }}
                    </template>
                </date-range-picker>
            </div>

            <chart-line-component v-if="loaded" :chart-data="chartData" :options="options"></chart-line-component>
        </div>
        <!-- /.card-body -->
    </div>
</template>

<script>
    import ChartLineComponent from "./ChartLineComponent";
    import axios from 'axios';
    import moment from 'moment';

    import DateRangePicker from 'vue2-daterange-picker'
    import 'vue2-daterange-picker/dist/vue2-daterange-picker.css'

    export default {
        name: "ChartComponent",
        props: ['title', 'id', 'keepalive'],
        components: {ChartLineComponent, DateRangePicker},
        data() {
            return {
                picker: null,
                dateRange: {
                    startDate: new Date(),
                    endDate: new Date()
                },
                loaded: false,
                chartData: null,
                options: {
                    responsive: true,
                    maintainAspectRatio: false
                }
            }
        },
        created() {
            this.getData();
        },
        methods: {
            getData() {
                this.loaded = false;

                var startDate = moment(String(this.dateRange.startDate)).format('YYYY-MM-DD 00:00:00')
                var endDate = moment(String(this.dateRange.endDate)).format('YYYY-MM-DD 23:59:59')

                axios.get('/api/probes/' + this.id + '/data', {
                    params: {
                        startDate: startDate,
                        endDate: endDate
                    }
                })
                    .then(response => {
                        var datasets = [
                            {
                                label: 'Température',
                                backgroundColor: '#f87979',
                                data: response.data.temperature
                            },
                            {
                                label: 'Humidité',
                                backgroundColor: '#5cc6f8',
                                data: response.data.humidity
                            }
                        ];

                        var labels = response.data.labels;

                        this.chartData = {
                            labels,
                            datasets
                        }

                        this.loaded = true;

                    })
                    .catch(function (error) {
                        console.log(error);
                    })
            },
        },
        filters: {
            date: function (value) {
                if (value) {
                    return moment(String(value)).format('DD/MM/YYYY')
                }
            }
        }
    }
</script>
